Index: trunk/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobView.cs
===================================================================
--- trunk/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobView.cs	(revision 10076)
+++ trunk/sources/HeuristicLab.Clients.Hive.JobManager/3.3/Views/RefreshableHiveJobView.cs	(revision 10130)
@@ -23,4 +23,5 @@
 using System.ComponentModel;
 using System.Linq;
+using System.Reflection;
 using System.Text;
 using System.Threading;
@@ -468,6 +469,13 @@
     private void jobsTreeView_DragEnter(object sender, DragEventArgs e) {
       e.Effect = DragDropEffects.None;
-      var obj = e.Data.GetData(Constants.DragDropDataFormat);
-      if (obj is IOptimizer) {
+      var obj = e.Data.GetData(Constants.DragDropDataFormat) as IDeepCloneable;
+      Type objType = obj.GetType();
+
+      var typeHiveTaskMap = ApplicationManager.Manager.GetTypes(typeof(ItemTask))
+          .Select(t => new Tuple<PropertyInfo, Type>(t.GetProperties().Single(x => x.Name == "Item" && x.PropertyType != typeof(IItem)), t));
+
+      var hiveTaskFound = typeHiveTaskMap.Any(x => x.Item1.PropertyType.IsAssignableFrom(objType));
+
+      if (hiveTaskFound) {
         if (Content.Id != Guid.Empty) e.Effect = DragDropEffects.None;
         else if ((e.KeyState & 32) == 32) e.Effect = DragDropEffects.Link;  // ALT key
@@ -478,21 +486,32 @@
     private void jobsTreeView_DragDrop(object sender, DragEventArgs e) {
       if (e.Effect != DragDropEffects.None) {
-        var obj = e.Data.GetData(Constants.DragDropDataFormat);
-
-        var optimizer = obj as IOptimizer;
-        if (optimizer != null) {
-          IOptimizer newOptimizer = null;
-          if (e.Effect.HasFlag(DragDropEffects.Copy)) {
-            newOptimizer = (IOptimizer)optimizer.Clone();
-            newOptimizer.Runs.Clear();
-          } else {
-            newOptimizer = optimizer;
+        var obj = e.Data.GetData(Constants.DragDropDataFormat) as IDeepCloneable;
+        Type objType = obj.GetType();
+
+        var typeHiveTaskMap = ApplicationManager.Manager.GetTypes(typeof(ItemTask))
+            .Select(t => new Tuple<PropertyInfo, Type>(t.GetProperties().Single(x => x.Name == "Item" && x.PropertyType != typeof(IItem)), t));
+
+        var hiveTaskType = typeHiveTaskMap.Single(x => x.Item1.PropertyType.IsAssignableFrom(objType)).Item2;
+
+        IDeepCloneable newObj = null;
+        if (e.Effect.HasFlag(DragDropEffects.Copy)) {
+          newObj = obj.Clone(new Cloner());
+        } else {
+          newObj = obj;
+        }
+
+        //IOptimizer and IExecutables need some special care
+        if (newObj is IOptimizer) {
+          ((IOptimizer)newObj).Runs.Clear();
+        }
+        if (newObj is IExecutable) {
+          IExecutable exec = newObj as IExecutable;
+          if (exec.ExecutionState != ExecutionState.Prepared) {
+            exec.Prepare();
           }
-          if (newOptimizer.ExecutionState != ExecutionState.Prepared) {
-            newOptimizer.Prepare();
-          }
-
-          Content.HiveTasks.Add(new OptimizerHiveTask(newOptimizer));
-        }
+        }
+
+        ItemTask hiveTask = Activator.CreateInstance(hiveTaskType, new object[] { newObj }) as ItemTask;
+        Content.HiveTasks.Add(hiveTask.CreateHiveTask());
       }
     }
Index: trunk/sources/HeuristicLab.Clients.Hive/3.3/HiveClient.cs
===================================================================
--- trunk/sources/HeuristicLab.Clients.Hive/3.3/HiveClient.cs	(revision 10076)
+++ trunk/sources/HeuristicLab.Clients.Hive/3.3/HiveClient.cs	(revision 10130)
@@ -362,5 +362,5 @@
         List<IPluginDescription> plugins;
 
-        if (hiveTask.ItemTask.ComputeInParallel && (hiveTask.ItemTask.Item is Optimization.Experiment || hiveTask.ItemTask.Item is Optimization.BatchRun)) {
+        if (hiveTask.ItemTask.ComputeInParallel) {
           hiveTask.Task.IsParentTask = true;
           hiveTask.Task.FinishWhenChildJobsFinished = true;
Index: trunk/sources/HeuristicLab.Clients.Hive/3.3/HiveTasks/EngineHiveTask.cs
===================================================================
--- trunk/sources/HeuristicLab.Clients.Hive/3.3/HiveTasks/EngineHiveTask.cs	(revision 10076)
+++ trunk/sources/HeuristicLab.Clients.Hive/3.3/HiveTasks/EngineHiveTask.cs	(revision 10130)
@@ -32,6 +32,6 @@
     #region Constructors and cloning
     public EngineHiveTask() { }
-    public EngineHiveTask(EngineTask engineJob, IScope parentScopeClone)
-      : base(engineJob) {
+    public EngineHiveTask(EngineTask engineTask, IScope parentScopeClone)
+      : base(engineTask) {
       this.parentScopeClone = parentScopeClone;
     }
Index: trunk/sources/HeuristicLab.Clients.Hive/3.3/HiveTasks/HiveTask.cs
===================================================================
--- trunk/sources/HeuristicLab.Clients.Hive/3.3/HiveTasks/HiveTask.cs	(revision 10076)
+++ trunk/sources/HeuristicLab.Clients.Hive/3.3/HiveTasks/HiveTask.cs	(revision 10130)
@@ -182,14 +182,14 @@
     }
 
-    public HiveTask(ItemTask itemJob, bool autoCreateChildHiveJobs)
+    public HiveTask(ItemTask itemTask, bool autoCreateChildHiveTasks)
       : this() {
-      this.syncTasksWithOptimizers = autoCreateChildHiveJobs;
-      this.ItemTask = itemJob;
+      this.syncTasksWithOptimizers = autoCreateChildHiveTasks;
+      this.ItemTask = itemTask;
       this.syncTasksWithOptimizers = true;
     }
 
-    public HiveTask(Task job, TaskData taskData, bool autoCreateChildHiveTasks) {
+    public HiveTask(Task task, TaskData taskData, bool autoCreateChildHiveTasks) {
       this.syncTasksWithOptimizers = autoCreateChildHiveTasks;
-      this.Task = job;
+      this.Task = task;
       try {
         this.ItemTask = PersistenceUtil.Deserialize<ItemTask>(taskData.Data);
@@ -545,5 +545,5 @@
     public new T ItemTask {
       get { return (T)base.ItemTask; }
-      internal set { base.ItemTask = value; }
+      set { base.ItemTask = value; }
     }
 
@@ -552,5 +552,5 @@
     [StorableConstructor]
     protected HiveTask(bool deserializing) { }
-    public HiveTask(T itemJob) : base(itemJob, true) { }
+    public HiveTask(T itemTask) : base(itemTask, true) { }
     protected HiveTask(HiveTask<T> original, Cloner cloner)
       : base(original, cloner) {
Index: trunk/sources/HeuristicLab.Clients.Hive/3.3/TaskDownloader.cs
===================================================================
--- trunk/sources/HeuristicLab.Clients.Hive/3.3/TaskDownloader.cs	(revision 10076)
+++ trunk/sources/HeuristicLab.Clients.Hive/3.3/TaskDownloader.cs	(revision 10130)
@@ -24,5 +24,4 @@
 using System.Linq;
 using System.Threading;
-using HeuristicLab.Clients.Hive.Jobs;
 using HeuristicLab.Common;
 
@@ -79,8 +78,8 @@
 
     public TaskDownloader(IEnumerable<Guid> jobIds) {
-      this.taskIds = jobIds;
-      this.taskDownloader = new ConcurrentTaskDownloader<ItemTask>(Settings.Default.MaxParallelDownloads, Settings.Default.MaxParallelDownloads);
-      this.taskDownloader.ExceptionOccured += new EventHandler<EventArgs<Exception>>(taskDownloader_ExceptionOccured);
-      this.results = new Dictionary<Guid, HiveTask>();
+      taskIds = jobIds;
+      taskDownloader = new ConcurrentTaskDownloader<ItemTask>(Settings.Default.MaxParallelDownloads, Settings.Default.MaxParallelDownloads);
+      taskDownloader.ExceptionOccured += new EventHandler<EventArgs<Exception>>(taskDownloader_ExceptionOccured);
+      results = new Dictionary<Guid, HiveTask>();
     }
 
@@ -88,16 +87,11 @@
       foreach (Guid taskId in taskIds) {
         taskDownloader.DownloadTaskDataAndTask(taskId,
-          (localJob, itemJob) => {
-            if (localJob != null && itemJob != null) {
-              HiveTask hiveTask;
-              if (itemJob is OptimizerTask) {
-                hiveTask = new OptimizerHiveTask((OptimizerTask)itemJob);
-              } else {
-                hiveTask = new HiveTask(itemJob, true);
-              }
-              hiveTask.Task = localJob;
+          (localTask, itemTask) => {
+            if (localTask != null && itemTask != null) {
+              HiveTask hiveTask = itemTask.CreateHiveTask();
+              hiveTask.Task = localTask;
               try {
                 resultsLock.EnterWriteLock();
-                this.results.Add(localJob.Id, hiveTask);
+                results.Add(localTask.Id, hiveTask);
               }
               finally { resultsLock.ExitWriteLock(); }
@@ -113,6 +107,6 @@
     public event EventHandler<EventArgs<Exception>> ExceptionOccured;
     private void OnExceptionOccured(Exception exception) {
-      this.exceptionOccured = true;
-      this.currentException = exception;
+      exceptionOccured = true;
+      currentException = exception;
       var handler = ExceptionOccured;
       if (handler != null) handler(this, new EventArgs<Exception>(exception));
Index: trunk/sources/HeuristicLab.Clients.Hive/3.3/Tasks/EngineTask.cs
===================================================================
--- trunk/sources/HeuristicLab.Clients.Hive/3.3/Tasks/EngineTask.cs	(revision 10076)
+++ trunk/sources/HeuristicLab.Clients.Hive/3.3/Tasks/EngineTask.cs	(revision 10130)
@@ -29,4 +29,9 @@
   [StorableClass]
   public class EngineTask : ItemTask {
+    public override HiveTask CreateHiveTask() {
+      //only used when deserializing, so no problem with parentscope
+      return new EngineHiveTask(this, null);
+    }
+
     [Storable]
     protected IOperation initialOperation;
@@ -52,4 +57,8 @@
     public EngineTask(IOperation initialOperation, IEngine engine) {
       this.initialOperation = initialOperation;
+      this.Item = engine;
+    }
+
+    public EngineTask(IEngine engine) {
       this.Item = engine;
     }
Index: trunk/sources/HeuristicLab.Clients.Hive/3.3/Tasks/ItemTask.cs
===================================================================
--- trunk/sources/HeuristicLab.Clients.Hive/3.3/Tasks/ItemTask.cs	(revision 10076)
+++ trunk/sources/HeuristicLab.Clients.Hive/3.3/Tasks/ItemTask.cs	(revision 10130)
@@ -31,6 +31,11 @@
   [StorableClass]
   public abstract class ItemTask : NamedItem, ITask {
+    public virtual HiveTask CreateHiveTask() {
+      return new HiveTask(this, true);
+    }
+
     public virtual bool IsParallelizable {
       get { return true; }
+      set { }
     }
 
Index: trunk/sources/HeuristicLab.Clients.Hive/3.3/Tasks/OptimizerTask.cs
===================================================================
--- trunk/sources/HeuristicLab.Clients.Hive/3.3/Tasks/OptimizerTask.cs	(revision 10076)
+++ trunk/sources/HeuristicLab.Clients.Hive/3.3/Tasks/OptimizerTask.cs	(revision 10130)
@@ -30,4 +30,8 @@
   [StorableClass]
   public class OptimizerTask : ItemTask {
+    public override HiveTask CreateHiveTask() {
+      return new OptimizerHiveTask(this);
+    }
+
     public override bool IsParallelizable {
       get { return this.Item is Experiment || this.Item is BatchRun; }
Index: trunk/sources/HeuristicLab.Hive/3.3/ITask.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive/3.3/ITask.cs	(revision 10076)
+++ trunk/sources/HeuristicLab.Hive/3.3/ITask.cs	(revision 10130)
@@ -33,5 +33,5 @@
     /// indicates wether it is possible to create childjobs from this job
     /// </summary>
-    bool IsParallelizable { get; }
+    bool IsParallelizable { get; set; }
 
     /// <summary>