Index: branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/DataSetStatisticInfo.cs
===================================================================
--- branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/DataSetStatisticInfo.cs	(revision 10148)
+++ branches/DataPreprocessing/HeuristicLab.DataPreprocessing/3.3/DataSetStatisticInfo.cs	(revision 10159)
@@ -1,35 +1,40 @@
 ﻿using System;
-using System.Linq;
-using HeuristicLab.Problems.DataAnalysis;
+using HeuristicLab.DataPreprocessing.Interfaces;
 
 namespace HeuristicLab.DataPreprocessing {
   class DatasetStatisticInfo : IDatasetStatisticInfo {
 
-    private IDataset dataSet;
+    private IPreprocessingData preprocessingData;
 
-    public DatasetStatisticInfo(IDataset theDataSet) {
-      dataSet = theDataSet;
+    public DatasetStatisticInfo(IPreprocessingData theDataSet) {
+      preprocessingData = theDataSet;
     }
 
 
     public int GetColumnCount() {
-      return dataSet.Columns;
+      return preprocessingData.Columns;
     }
 
     public int GetRowCount() {
-      return dataSet.Rows;
+      return preprocessingData.Rows;
     }
 
     public int GetNumericColumnCount() {
-      return dataSet.DoubleVariables.Count();
+      int count = 0;
+      for (int i = 0; i < preprocessingData.Columns; ++i) {
+        if (preprocessingData.IsType<double>(i)) {
+          ++count;
+        }
+      }
+      return count;
     }
 
     public int GetNominalColumnCount() {
-      return dataSet.Columns - GetNumericColumnCount();
+      return preprocessingData.Columns - GetNumericColumnCount();
     }
 
     public int GetMissingValueCount() {
       int count = 0;
-      for (int i = 0; i < dataSet.Columns; ++i) {
+      for (int i = 0; i < preprocessingData.Columns; ++i) {
         count += GetMissingValueCount(i);
       }
@@ -38,22 +43,23 @@
 
     public int GetMissingValueCount(int columnIndex) {
-      Func<string, bool> isMissingValueFunc;
-      if (dataSet.IsType<double>(columnIndex)) {
-        isMissingValueFunc = IsMissingDoubleValue;
-      } else if (dataSet.IsType<string>(columnIndex)) {
-        isMissingValueFunc = IsMissingStringValue;
-      } else if (dataSet.IsType<DateTime>(columnIndex)) {
-        isMissingValueFunc = isMissingDateTimeValue;
-      } else {
-        throw new ArgumentException("column with index: " + columnIndex + " contains a non supported type.");
-      }
+      throw new System.NotImplementedException();
+      //Func<dynamic, bool> isMissingValueFunc;
+      //if (preprocessingData.IsType<double>(columnIndex)) {
+      //  isMissingValueFunc = IsMissingDoubleValue;
+      //} else if (preprocessingData.IsType<string>(columnIndex)) {
+      //  isMissingValueFunc = IsMissingStringValue;
+      //} else if (preprocessingData.IsType<DateTime>(columnIndex)) {
+      //  isMissingValueFunc = isMissingDateTimeValue;
+      //} else {
+      //  throw new ArgumentException("column with index: " + columnIndex + " contains a non supported type.");
+      //}
 
-      int count = 0;
-      for (int i = 0; i < dataSet.Rows; ++i) {
-        if (isMissingValueFunc(dataSet.GetValue(i, columnIndex))) {
-          ++count;
-        }
-      }
-      return count;
+      //int count = 0;
+      //for (int i = 0; i < preprocessingData.Rows; ++i) {
+      //  if (isMissingValueFunc(preprocessingData.GetCell(i, columnIndex))) {
+      //    ++count;
+      //  }
+      //}
+      //return count;
     }
 
@@ -75,5 +81,5 @@
 
     public T GetMin<T>(int columnIndex) where T : IComparable<T> {
-      if (!dataSet.IsType<double>(columnIndex)) {
+      if (!preprocessingData.IsType<double>(columnIndex)) {
         throw new ArgumentException("column with index: " + columnIndex + " was assumed to be of type " + typeof(T).Name + " but was different.");
       }
@@ -88,5 +94,5 @@
 
     public T GetMax<T>(int columnIndex) where T : IComparable<T> {
-      if (!dataSet.IsType<double>(columnIndex)) {
+      if (!preprocessingData.IsType<double>(columnIndex)) {
         throw new ArgumentException("column with index: " + columnIndex + " was assumed to be of type " + typeof(T).Name + " but was different.");
       }
@@ -101,34 +107,36 @@
 
     private T GetMin<T>(int columnIndex, T max, Func<string, bool> isMissingValueFunc, Func<string, T> parseFunc) where T : IComparable<T> {
-      T min = max;
-      for (int i = 0; i < dataSet.Rows; ++i) {
-        var value = dataSet.GetValue(i, columnIndex);
-        if (!isMissingValueFunc(value)) {
-          T parsedValue = parseFunc(value);
-          if (parsedValue.CompareTo(min) < 0) {
-            min = parsedValue;
-          }
-        }
-      }
-      return min;
+      throw new System.NotImplementedException();
+      //T min = max;
+      //for (int i = 0; i < preprocessingData.Rows; ++i) {
+      //  var value = preprocessingData.GetValue(i, columnIndex);
+      //  if (!isMissingValueFunc(value)) {
+      //    T parsedValue = parseFunc(value);
+      //    if (parsedValue.CompareTo(min) < 0) {
+      //      min = parsedValue;
+      //    }
+      //  }
+      //}
+      //return min;
     }
 
     private T GetMax<T>(int columnIndex, T min, Func<string, bool> isMissingValueFunc, Func<string, T> parseFunc) where T : IComparable<T> {
-      T max = min;
-      for (int i = 0; i < dataSet.Rows; ++i) {
-        var value = dataSet.GetValue(i, columnIndex);
-        if (!isMissingValueFunc(value)) {
-          T parsedValue = parseFunc(value);
-          if (parsedValue.CompareTo(min) > 0) {
-            max = parsedValue;
-          }
-        }
-      }
-      return max;
+      throw new System.NotImplementedException();
+      //T max = min;
+      //for (int i = 0; i < preprocessingData.Rows; ++i) {
+      //  var value = preprocessingData.GetValue(i, columnIndex);
+      //  if (!isMissingValueFunc(value)) {
+      //    T parsedValue = parseFunc(value);
+      //    if (parsedValue.CompareTo(min) > 0) {
+      //      max = parsedValue;
+      //    }
+      //  }
+      //}
+      //return max;
     }
 
 
 
-   
+
 
     public double GetMedian(int columnIndex) {
@@ -141,8 +149,12 @@
 
     public double GetMostCommonValue(int columnIndex) {
-      throw new System.NotImplementedException();
+      double result = 0;
+      for (int i = 0; i < preprocessingData.Rows; ++i) {
+
+      }
+      return result;
     }
 
-    public double GeStandardDeviation(int columnIndex) {
+    public double GetStandardDeviation(int columnIndex) {
       throw new System.NotImplementedException();
     }