Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/ClassificationEnsembleSolutionView.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/ClassificationEnsembleSolutionView.cs	(revision 10174)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/ClassificationEnsembleSolutionView.cs	(revision 10175)
@@ -37,4 +37,11 @@
     }
 
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      //loading of problemdata is currently not support for ensemble solutions
+      loadProblemDataButton.Enabled = false;
+      loadProblemDataButton.Visible = false;
+    }
+
     protected override void OnContentChanged() {
       base.OnContentChanged();
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/ClassificationSolutionView.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/ClassificationSolutionView.cs	(revision 10174)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/ClassificationSolutionView.cs	(revision 10175)
@@ -22,4 +22,5 @@
 using System;
 using System.Windows.Forms;
+using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.MainForm;
@@ -55,5 +56,9 @@
 
     protected override bool CheckCompatibilityOfProblemData(IDataAnalysisProblemData problemData) {
-      IClassificationProblemData classificationProblemData = (IClassificationProblemData)problemData;
+      IClassificationProblemData classificationProblemData = problemData as IClassificationProblemData;
+      if (classificationProblemData == null) {
+        ErrorHandling.ShowErrorDialog(this, new ArgumentException("The problem data is no classification problem data. Instead a " + problemData.GetType().GetPrettyName() + " was provided."));
+        return false;
+      }
 
       if (!classificationProblemData.TargetVariable.Equals(Content.ProblemData.TargetVariable)) {
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/DataAnalysisSolutionView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/DataAnalysisSolutionView.Designer.cs	(revision 10174)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/DataAnalysisSolutionView.Designer.cs	(revision 10175)
@@ -19,4 +19,6 @@
  */
 #endregion
+
+
 namespace HeuristicLab.Problems.DataAnalysis.Views {
   partial class DataAnalysisSolutionView {
@@ -46,4 +48,6 @@
       this.exportButton = new System.Windows.Forms.Button();
       this.exportFileDialog = new System.Windows.Forms.SaveFileDialog();
+      this.loadProblemDataButton = new System.Windows.Forms.Button();
+      this.loadProblemDataFileDialog = new System.Windows.Forms.OpenFileDialog();
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).BeginInit();
       this.splitContainer.Panel1.SuspendLayout();
@@ -59,4 +63,5 @@
       // splitContainer.Panel2
       // 
+      this.splitContainer.Panel2.Controls.Add(this.loadProblemDataButton);
       this.splitContainer.Panel2.Controls.Add(this.exportButton);
       // 
@@ -76,11 +81,28 @@
       // 
       this.exportButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
-      this.exportButton.Location = new System.Drawing.Point(215, 4);
+      this.exportButton.Location = new System.Drawing.Point(194, 3);
       this.exportButton.Name = "exportButton";
-      this.exportButton.Size = new System.Drawing.Size(54, 23);
+      this.exportButton.Size = new System.Drawing.Size(75, 24);
       this.exportButton.TabIndex = 6;
       this.exportButton.Text = "Export";
       this.exportButton.UseVisualStyleBackColor = true;
       this.exportButton.Click += new System.EventHandler(this.exportButton_Click);
+      //
+      // loadProblemDataButton
+      //
+      this.loadProblemDataButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)));
+      this.loadProblemDataButton.Location = new System.Drawing.Point(3, 3);
+      this.loadProblemDataButton.Name = "loadProblemDataButton";
+      this.loadProblemDataButton.Size = new System.Drawing.Size(75, 24);
+      this.loadProblemDataButton.TabIndex = 7;
+      this.loadProblemDataButton.Text = "Load Data";
+      this.loadProblemDataButton.UseVisualStyleBackColor = true;
+      this.loadProblemDataButton.Click += new System.EventHandler(this.loadProblemDataButton_Click);
+      this.toolTip.SetToolTip(this.loadProblemDataButton, "Load new data");
+      // 
+      // openFileDialog
+      // 
+      this.loadProblemDataFileDialog.Filter = "HL files|*.hl";
+      this.loadProblemDataFileDialog.Title = "Load new ProblemData or Problem...";
       // 
       // DataAnalysisSolutionView
@@ -102,4 +124,6 @@
     private System.Windows.Forms.SaveFileDialog exportFileDialog;
     protected System.Windows.Forms.Button exportButton;
+    protected System.Windows.Forms.Button loadProblemDataButton;
+    protected System.Windows.Forms.OpenFileDialog loadProblemDataFileDialog;
 
   }
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/DataAnalysisSolutionView.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/DataAnalysisSolutionView.cs	(revision 10174)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/DataAnalysisSolutionView.cs	(revision 10175)
@@ -32,4 +32,5 @@
 using HeuristicLab.Optimization;
 using HeuristicLab.Optimization.Views;
+using HeuristicLab.Persistence.Default.Xml;
 using HeuristicLab.PluginInfrastructure;
 
@@ -55,6 +56,8 @@
       if (Content == null) {
         exportButton.Enabled = false;
+        loadProblemDataButton.Enabled = false;
       } else {
         exportButton.Enabled = !Locked;
+        loadProblemDataButton.Enabled = !Locked;
       }
     }
@@ -128,4 +131,30 @@
     }
 
+    protected virtual void loadProblemDataButton_Click(object sender, EventArgs e) {
+      if (loadProblemDataFileDialog.ShowDialog(this) != DialogResult.OK) return;
+      object hlFile = XmlParser.Deserialize(loadProblemDataFileDialog.FileName);
+
+      IDataAnalysisProblemData problemData = null;
+      if (hlFile is IDataAnalysisProblemData) {
+        problemData = (IDataAnalysisProblemData)hlFile;
+      } else if (hlFile is IDataAnalysisProblem) {
+        problemData = ((IDataAnalysisProblem)hlFile).ProblemData;
+      } else if (hlFile is IDataAnalysisSolution) {
+        problemData = ((IDataAnalysisSolution)hlFile).ProblemData;
+      }
+
+      if (problemData == null) {
+        ErrorHandling.ShowErrorDialog(this, new NullReferenceException("The problem data is null." + Environment.NewLine
+                                      + "The .hl-file contains no DataAnalysisProblemData or DataAnylsisProblem."));
+        return;
+      }
+
+      if (CheckCompatibilityOfProblemData(problemData)) {
+        var solution = (IDataAnalysisSolution)Content.Clone();
+        solution.ProblemData = problemData;
+        solution.Name += " with loaded problem data (" + loadProblemDataFileDialog + ")";
+        MainFormManager.MainForm.ShowContent(solution);
+      }
+    }
 
     private void exportButton_Click(object sender, EventArgs e) {
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionEnsembleSolutionView.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionEnsembleSolutionView.cs	(revision 10174)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionEnsembleSolutionView.cs	(revision 10175)
@@ -32,4 +32,11 @@
     }
 
+    protected override void SetEnabledStateOfControls() {
+      base.SetEnabledStateOfControls();
+      //loading of problemdata is currently not support for ensemble solutions
+      loadProblemDataButton.Enabled = false;
+      loadProblemDataButton.Visible = false;
+    }
+
     public new RegressionEnsembleSolution Content {
       get { return (RegressionEnsembleSolution)base.Content; }
Index: trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.cs
===================================================================
--- trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.cs	(revision 10174)
+++ trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Solution Views/RegressionSolutionView.cs	(revision 10175)
@@ -22,4 +22,5 @@
 using System;
 using System.Windows.Forms;
+using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.MainForm;
@@ -55,5 +56,9 @@
 
     protected override bool CheckCompatibilityOfProblemData(IDataAnalysisProblemData problemData) {
-      IRegressionProblemData regressionProblemData = (IRegressionProblemData)problemData;
+      IRegressionProblemData regressionProblemData = problemData as IRegressionProblemData;
+      if (regressionProblemData == null) {
+        ErrorHandling.ShowErrorDialog(this, new ArgumentException("The problem data is no regression problem data. Instead a " + problemData.GetType().GetPrettyName() + " was provided."));
+        return false;
+      }
 
       if (!regressionProblemData.TargetVariable.Equals(Content.ProblemData.TargetVariable)) {